ST = {};
_G['ST'] = ST;

ST.events = { "VARIABLES_LOADED", "SYSTEM_MESSAGE", "CHAT_MSG_GUILD", "CHAT_MSG_PARTY", "CHAT_MSG_SAY", "LOADING_END" };

ST.Name = "Myaff Share Target";

ST.Text = "[ST] Take my target";
STVariables = {};
ST.DefaultConfig = {
	["Enabled"] = false,
	["InGuild"] = true,
	["InParty"] = false,
	["InSay"] = false,
};

SLASH_MSHARETARGET1 = "/st";
SlashCmdList["MSHARETARGET"] = function(_, msg)
	if( msg == "status" )then
		ST.StatusMessage();
		return nil;
	end;

	if( msg == "enable" )then
		STVariables.Enabled = true;
		ST.Message( "Addon " .. MLib.YESPattern:format( "Enabled" ) );
		return nil;
	end;
	if( msg == "disable" )then
		STVariables.Enabled = false;
		ST.Message( "Addon " .. MLib.NOPattern:format( "Disabled" ) );
		return nil;
	end;
	if( msg == "guild" )then
		STVariables.InGuild = not STVariables.InGuild;
		if( STVariables.InGuild )then
			ST.Message( "Messages in guild: " .. MLib.YESPattern:format( "Yes" ) );
		else
			ST.Message( "Messages in guild: " .. MLib.NOPattern:format( "No" ) );
		end;
		return nil;
	end;
	if( msg == "party" )then
		STVariables.InParty = not STVariables.InParty;
		if( STVariables.InParty )then
			ST.Message( "Messages in party: " .. MLib.YESPattern:format( "Yes" ) );
		else
			ST.Message( "Messages in party: " .. MLib.NOPattern:format( "No" ) );
		end;
		return nil;
	end;
	if( msg == "say" )then
		STVariables.InSay = not STVariables.InSay;
		if( STVariables.InSay )then
			ST.Message( "Messages in say: " .. MLib.YESPattern:format( "Yes" ) );
		else
			ST.Message( "Messages in say: " .. MLib.NOPattern:format( "No" ) );
		end;
		return nil;
	end;
	ST.Message( "Unknown command /st " .. msg );
	ST.Message( "Use /st <enable/disable/guild/party/say> for configure" );
	ST.Message( "Use /st status for display configuration" );
end;

function ST.Message( text, frames )
	MLib.Message( text, "ST", frames );
end;

function ST.OnLoad( this )
	for n = 1, #ST.events do
		this:RegisterEvent( ST.events[ n ] );
	end;
end;

function ST.OnEvent( this, event )
	if( event == "VARIABLES_LOADED" )then
		for key, value in pairs( ST.DefaultConfig )do
			if( STVariables[ key ] == nil )then STVariables[ key ] = value; end;
		end;
		SaveVariables( "STVariables" );
		ST.Message( "Share Target loading successfully complete" );
		ST.StatusMessage();
		ST.Message( "Use /st <enable/disable/guild/party/say> for configure" );
		ST.Message( "Use /st status for display configuration" );
	end;
	if( event == "CHAT_MSG_GUILD" )or( event == "CHAT_MSG_PARTY" )or( event == "CHAT_MSG_SAY" )then
		if( STVariables.Enabled )then
			if( arg1 == ST.Text )then
				-- arg2 [nick]
				-- arg4 nick
				for n = 1, 36 do
					if( UnitName( "raid" .. n ) == arg4 )then
						TargetUnit( "raid" .. n .. "target" );
					end;
				end;
			end;
		end;
	end;
end;

function ST.StatusMessage()
	if( STVariables.Enabled )then
		ST.Message( "Addon " .. MLib.YESPattern:format( "Enabled" ) );
	else
		ST.Message( "Addon " .. MLib.NOPattern:format( "Disabled" ) );
	end;
	if( STVariables.InGuild )then
		ST.Message( "Messages in guild: " .. MLib.YESPattern:format( "Yes" ) );
	else
		ST.Message( "Messages in guild: " .. MLib.NOPattern:format( "No" ) );
	end;
	if( STVariables.InParty )then
		ST.Message( "Messages in party: " .. MLib.YESPattern:format( "Yes" ) );
	else
		ST.Message( "Messages in party: " .. MLib.NOPattern:format( "No" ) );
	end;
	if( STVariables.InSay )then
		ST.Message( "Messages in say: " .. MLib.YESPattern:format( "Yes" ) );
	else
		ST.Message( "Messages in say: " .. MLib.NOPattern:format( "No" ) );
	end;
end;

function ST.ShareMessage()
	
	if( STVariables.InGuild )then SendChatMessage( ST.Text, "GUILD" ); end;
	if( STVariables.InParty )then SendChatMessage( ST.Text, "PARTY" ); end;
	if( STVariables.InSay )then SendChatMessage( ST.Text, "SAY" ); end;
end;
